; Z88 CamelForth
; camelinf.s (Interpreter words without support for files)


;X SAVE-INPUT	-- x1...xn n
;   >IN @  SOURCE  SOURCE-ID  BLK @
;   5 ;
    head SAVEINPUT,10,"SAVE-INPUT",docolon,0,0
	defw TOIN,FETCH,SOURCE,SOURCEID,BLK,FETCH
	defw LIT,5,EXIT


;X RESTORE-INPUT	x1...xn n -- flag
;   ?DUP 0= IF  TRUE EXIT  THEN		; can't restore a null input
;   DUP 5 =
;   IF  DROP
;	BLK !  'SOURCE-ID !  'SOURCE 2!  >IN !
;       FALSE
;   ELSE  FOR  DROP  STEP
;	  TRUE
;   THEN ;
    head RESTOREINPUT,13,"RESTORE-INPUT",docolon,0,0
	defw QDUP,ZEROEQUAL,QBRANCH,rstip1
	defw TRUE,EXIT
.rstip1 defw DUP,LIT,5,EQUAL
	defw QBRANCH,rstip2
	defw DROP
	defw BLK,STORE,TICKSOURCEID,STORE,TICKSOURCE,TWOSTORE,TOIN,STORE
	defw FALSE
	defw BRANCH,rstip4
.rstip2 defw TOR
.rstip3 defw DROP,BRSTEP,rstip3
	defw TRUE
.rstip4 defw EXIT


;X REFILL   -- f
;   SOURCE-ID BLK @ OR 0= DUP
;   IF  TIB DUP 80 ACCEPT SPACE
;	'SOURCE 2!  0 >IN !
;   THEN ;
    head REFILL,6,"REFILL",docolon,0,0
	defw SOURCEID,BLK,FETCH,OR,ZEROEQUAL,DUP
	defw QBRANCH,refil1
        defw TIB,DUP,LIT,80,ACCEPT,SPACE
	defw TICKSOURCE,TWOSTORE
	defw ZERO,TOIN,STORE
.refil1 defw EXIT


;C (    --                     skip input until )
;   [CHAR] ) PARSE 2DROP ; IMMEDIATE
    head PAREN,1,"(",docolon,1,0
        defw LIT,$29,PARSE,TWODROP,EXIT


;C S"       --         compile in-line string
;   POSTPONE (S") (") ; IMMEDIATE
    head SQUOTE,2,"S"&$22,docolon,1,0
        defw LIT,XSQUOTE,COMMAXT
        defw BRQUOTE,EXIT

;X \		-- comments to end of line
;   SOURCE NIP >IN ! ; IMMEDIATE
    head BACKSLASH,1,"\",docolon,1,0
	defw SOURCE,NIP,TOIN,STORE,EXIT


